
#include "trans.h"
#include "qsort.h"
#include "fptN20.h"
#include <math.h>
#ifndef _WIN32
#include <sys/resource.h>
#include <sys/times.h>
#include <unistd.h>
#endif

extern FILE *debugFilePtr;
extern FILE *countFilePtr;
extern int noOfSlot;
extern int memoryUsage;

extern double epsilon;


int f1;


void printBucket(FILE *filePtr, entryPtr *bucket, int *noOfEntry, int L)
{
	int i, j, k;

	for (i = 0; i < L; i++)
	{
		//printf("   Size %d\n", i+1);
		//printf("   ~~~~~~~\n");
//		fprintf(filePtr, "   Size %d\n", i+1);
//		fprintf(filePtr, "   ~~~~~~~\n");
		for (k = 0; k < noOfEntry[i]; k++)
		{
		
			//printf("  Entry %d (Size %d)\t     ", i, bucket[i][k].itemsetSize);
//			fprintf(filePtr, "  Entry %d (Size %d)\t     ", i, bucket[i][k].itemsetSize);
			for (j = 0; j < bucket[i][k].itemsetSize; j++)
			{
				//printf("%d ", bucket[i][k].item[j]);
//				fprintf(filePtr, "%d ", bucket[i][k].item[j]);
			}
			//printf("\t\t%d\n", bucket[i][k].count);
//			fprintf(filePtr,"\t\t%d\n", bucket[i][k].count);
		}
	}
}

transPtr *readData(char *filename, int noOfTrans)
{
	FILE *filePtr;
	transPtr *returnValue;
	int transNo;

	int i, j;

	transPtr tempValue;

	filePtr = (FILE *) fopen(filename, "r");
	if (filePtr == NULL)
	{
		printf("File %s cannot be opened!\n", filename);
		exit(0);
	}

	returnValue = (transPtr *) malloc(sizeof(transPtr)*noOfTrans);

	transNo = 0;

	// skip 
	tempValue = (transPtr) malloc(sizeof(trans));
	for (j = 0; j < noOfSkip; j++)
	{
		fscanf(filePtr, "%d", &(tempValue->noOfItem));

		tempValue->item = (int *) malloc(sizeof(int)*tempValue->noOfItem);

		for (i = 0; i < tempValue->noOfItem; i++)
		{
			fscanf(filePtr, " %d", &(tempValue->item[i]));
		}

		fscanf(filePtr, "\n");

		free(tempValue);
	}
	

	//while (!feof(filePtr))
	for (j = 0; j < noOfTrans; j++)
	{
		returnValue[transNo] = (transPtr) malloc(sizeof(trans));

		fscanf(filePtr, "%d", &(returnValue[transNo]->noOfItem));

		returnValue[transNo]->item = (int *) malloc(sizeof(int)*returnValue[transNo]->noOfItem);

		for (i = 0; i < returnValue[transNo]->noOfItem; i++)
		{
			fscanf(filePtr, " %d", &(returnValue[transNo]->item[i]));
		}

		fscanf(filePtr, "\n");

		transNo++;
	}

	fclose(filePtr);

	return returnValue;
}




void addEntry(entryPtr *bucket, int noOfPreEntry, int *itemset, int itemsetSize, int freq)
{
	entryPtr tempBucket;

	int i;

	entryPtr bucketProcess;
	int noOfEntryProcess;

	noOfEntryProcess = noOfPreEntry;
	bucketProcess = (*bucket);

	tempBucket = (entryPtr) malloc(sizeof(entry)*(noOfEntryProcess+1));

	for (i = 0; i < noOfEntryProcess; i++)
	{
		tempBucket[i].itemsetSize = bucketProcess[i].itemsetSize;
		tempBucket[i].item = bucketProcess[i].item;
		tempBucket[i].count = bucketProcess[i].count;
	}

	tempBucket[noOfEntryProcess].itemsetSize = itemsetSize;
	//tempBucket[noOfEntryProcess].item = itemset;
	tempBucket[noOfEntryProcess].item = (int *) malloc(sizeof(int)*itemsetSize);
	memcpy(tempBucket[noOfEntryProcess].item, itemset, sizeof(int)*itemsetSize);
	tempBucket[noOfEntryProcess].count = freq;

	free(bucketProcess);

	(*bucket) = tempBucket;
}

// need to free bucketOld explicitly
void freeBucket(entryPtr *bucketOld, int *noOfEntryOld, int L)
{
	int i, j;

	for (i = 0; i < L; i++)
	{
		for (j = 0; j < noOfEntryOld[i]; j++)
		{
			free(bucketOld[i][j].item);
		}
		if (noOfEntryOld[i] != 0)
			free(bucketOld[i]);
	}

}

// curNoOfBucket : the no. of buckets NOT including the newly buckets added
void switchBucket(entryPtr **bucket, int curNoOfBucket, int noOfBucket, entryPtr *newBucket, int *noOfEntryNew, int L, int **noOfEntry)
{
	int i, j;

	entryPtr *oldBucket;
	int *noOfEntryOld;

	oldBucket = (entryPtr *) malloc(sizeof(entryPtr)*L);
	noOfEntryOld = (int *) malloc(sizeof(int)*L);
	memset(noOfEntryOld, 0, sizeof(int)*L);


	for (i = 0; i < L; i++)
	{
		oldBucket[i] = bucket[0][i];
		noOfEntryOld[i] = noOfEntry[0][i];
	}

	if (curNoOfBucket < noOfBucket)
	{
		//for (i = 0; i < curNoOfBucket-1; i++)
		//{
		//	for (j = 0; j < L; j++)
		//	{
		//		bucket[i][j] = bucket[i+1][j];
		//		noOfEntry[i][j] = noOfEntry[i+1][j];
		//	}
		//}

		for (j = 0; j < L; j++)
		{
			bucket[curNoOfBucket][j] = newBucket[j];
			noOfEntry[curNoOfBucket][j] = noOfEntryNew[j];
		}
	}
	else
	{
		for (i = 0; i < curNoOfBucket-1; i++)
		{
			for (j = 0; j < L; j++)
			{
				bucket[i][j] = bucket[i+1][j];
				noOfEntry[i][j] = noOfEntry[i+1][j];
			}
		}
		
		for (j = 0; j < L; j++)
		{
			bucket[noOfBucket-1][j] = newBucket[j];
			noOfEntry[noOfBucket-1][j] = noOfEntryNew[j];
		}

	}


	if (curNoOfBucket == noOfBucket)
	{
		freeBucket(oldBucket, noOfEntryOld, L);
		//free(oldBucket);
	}


/*

	for (i = 0; i < L; i++)
	{
		oldBucket[i] = bucket[curNoOfBucket-1][i];
		noOfEntryOld[i] = noOfEntry[curNoOfBucket-1][i];
	}

	if (curNoOfBucket < noOfBucket)
	{
		for (i = curNoOfBucket-1; i >= 0 ; i--)
		{
			for (j = 0; j < L; j++)
			{
				bucket[i+1][j] = bucket[i][j];
				noOfEntry[i+1][j] = noOfEntry[i][j];
			}
		}
	}
	else
	{
		for (i = curNoOfBucket-2; i >= 0; i--)
		{
			for (j = 0; j < L; j++)
			{
				bucket[i+1][j] = bucket[i][j];
				noOfEntry[i+1][j] = noOfEntry[i][j];
			}
		}
	}
	for (j = 0; j < L; j++)
	{
		bucket[0][j] = newBucket[j];
		noOfEntry[0][j] = noOfEntryNew[j];
	}

	if (curNoOfBucket == noOfBucket)
	{
		freeBucket(oldBucket, noOfEntryOld, L);
		//free(oldBucket);
	}
*/
	free(noOfEntryOld);
	free(oldBucket);
}


int findOptimalRank(int K, int noOfBucket, double theta, int m)
{
	int returnValue;

	

	// round
	//returnValue = (int) ((K*pow(1+2*(noOfBucket-1.0), 1.0/theta)) + 0.5);
	//returnValue = (int) (K*pow(2*noOfBucket*(noOfBucket-1)*(1+1.0/epsilon), 1.0/theta) +0.5);
	returnValue = (int) (pow(noOfBucket*(noOfBucket-1)/(1/(2*pow(K, theta)*(1+1.0/epsilon)) + (noOfBucket-1)/m), 1.0/theta) +0.5);
printf("~~~~~~~~~~~~optimal rank:%d\n", returnValue);
	return returnValue;
}

// noOfEntry : should be passed by reference
// curNoOfBucket : does not include the newly bucket
entryPtr *createNewBucket(char *filename, int startIndex, int endIndex, int topK, int L, double *theta, entryPtr **bucket, int **noOfEntry, int curNoOfBucket, int noOfBucket, int *noOfEntryNew, int bucketSize)
{
	entryPtr *returnValue;
	int K1;

	//int **topItemset;
	//int *topSize;
	//int *topFreq;

	//int i;	

	

	// dummy
	//int *noOfTopK;
	//int K = 4;
	//char *filename = "file.txt";

	entryPtr *newBucket;

	//noOfTopK = (int *) malloc(sizeof(int)*L);

	if (curNoOfBucket == 0)
	{

		// finding top K1 frequent itemset

	
		K1 = findOptimalRank(topK, noOfBucket, theta[0], noOfBucket*bucketSize);

		//entryPtr processBOMO(char *configFilename, int startIndex, int bucketSize, int topK, int K, int *noOfTopK)

		newBucket = processBOMO(filename, startIndex, endIndex-startIndex+1, K1, L, noOfEntryNew);

/*
		// simulate
		K1 = 10;
		topSize = (int *) malloc(sizeof(int)*K1);
		topFreq = (int *) malloc(sizeof(int)*K1);
		memset(topSize, 0, sizeof(int)*K1);
		memset(topFreq, 0, sizeof(int)*K1);
		topItemset = (int **) malloc(sizeof(int *)*K1);
		for (i = 0; i < K1; i++)
		{
			topItemset[i] = (int *) malloc(sizeof(int)*2);
			memset(topItemset[i], 0, sizeof(int)*2);
		}


		// insert the frequent itemsets in the bucket
		returnValue = (entryPtr) malloc(sizeof(entry)*K1);
		for (i = 0; i < K1; i++)
		{
			addEntry(&returnValue, i, topItemset[i], topSize[i], topFreq[i]);
		}
*/
		//(*noOfEntryNew) = K1;
		//(*noOfEntryNew) = noOfTopK;

		returnValue = newBucket;
	}
	else
	{
		returnValue = findNewBucket(filename, startIndex, endIndex, bucket, curNoOfBucket, noOfBucket, noOfEntry, topK, L, theta, noOfEntryNew, bucketSize);

		//(*noOfEntryNew) = noOfTopK;
	}

	//free(noOfTopK);
	return returnValue;
}

void addBucketNo(hashEntryPtr hashEntry, int bucketNo)
{
	short *tempBucket;

	int no;

	if (hashEntry->noOfBucket == 0)
	{
		hashEntry->bucketNo = (short *) malloc(sizeof(short));
		hashEntry->bucketNo[0] = bucketNo;
	}
	else
	{
		tempBucket = (short *) malloc(sizeof(short)*hashEntry->noOfBucket);
		memcpy(tempBucket, hashEntry->bucketNo, sizeof(short)*hashEntry->noOfBucket);

		free(hashEntry->bucketNo);
		no = hashEntry->noOfBucket;
		hashEntry->bucketNo = (short *) malloc(sizeof(short)*(no+1));
		memcpy(hashEntry->bucketNo, tempBucket, sizeof(short)*no);

		hashEntry->bucketNo[no] = bucketNo;

		free(tempBucket);
	}

	hashEntry->noOfBucket++;
}

void top_sortItemset(int *itemset, int itemSize)
{
	int i, j;
	int temp;

	for (i = 0; i < itemSize; i++)
	{
		for (j = 0; j < itemSize-1-i; j++)
		{
			if (itemset[j] > itemset[j+1])
			{
				// swap
				temp = itemset[j];
				itemset[j] = itemset[j+1];
				itemset[j+1] = temp;
			}
		}
	}
}

void ans_addEntry(int bucketNo, int *itemSet, int itemSize, int freq, hashPtr hash, int noOfSlot)
{
	hashEntryPtr hashEntry;

	hashEntryPtr tempHashEntry;

	int isSame;

	int newNoOfEntry;

	int hashValue;

	int i, j;

	// searching whether it is in the node

	top_sortItemset(itemSet, itemSize);
//if (itemSize == 2) printf(" Sorted: <%d %d>\n", itemSet[0], itemSet[1]);
	// calculate the hashValue
	hashValue = 0;
	for (i = 0; i < itemSize; i++)
	{
		hashValue += itemSet[i];
	}
	hashValue = hashValue%noOfSlot;

	// check whether this itemset is in the hash
	isSame = 0;
	hashEntry = hash[hashValue].entry;
	for (i = 0; i < hash[hashValue].noOfEntry; i++)
	{
		// check whether the entry is equal to the this itemset
		if (itemSize == hashEntry[i].itemSize)
		{
			isSame = 1;
			for (j = 0; j < itemSize; j++)
			{
				if (hashEntry[i].itemSet[j] != itemSet[j])
				{
					isSame = 0;
					break;
				}
			}

			// if same
			if (isSame == 1)
			{
				hashEntry[i].freq += freq;

				addBucketNo(&(hashEntry[i]), bucketNo);
				break;
			}
		}
	}

	if (isSame == 1)
	{
	}
	else
	{
		// does not occur in Hash
		if (hash[hashValue].noOfEntry != 0)
		{
			tempHashEntry = (hashEntryPtr) malloc(sizeof(hashEntryStruct)*hash[hashValue].noOfEntry);
		
			memcpy(tempHashEntry, hashEntry, sizeof(hashEntryStruct)*hash[hashValue].noOfEntry);
		
			free(hashEntry);
		}

		hash[hashValue].noOfEntry++;
		newNoOfEntry = hash[hashValue].noOfEntry;
		hash[hashValue].entry = (hashEntryPtr) malloc(sizeof(hashEntryStruct)*newNoOfEntry);
		hashEntry = hash[hashValue].entry;
		memset(hashEntry, 0, sizeof(hashEntryStruct)*newNoOfEntry);
	
		if (newNoOfEntry != 1)
		{
			memcpy(hashEntry, tempHashEntry, sizeof(hashEntryStruct)*(newNoOfEntry-1));
			free(tempHashEntry);
		}

		// add the new at the end
		hashEntry[newNoOfEntry-1].itemSize = itemSize;
		hashEntry[newNoOfEntry-1].itemSet = (int *) malloc(sizeof(int)*itemSize);
		for (i = 0; i < itemSize; i++)
		{
			hashEntry[newNoOfEntry-1].itemSet[i] = itemSet[i];
		}
		hashEntry[newNoOfEntry-1].freq = freq;
		hashEntry[newNoOfEntry-1].freqNew = 0;
		hashEntry[newNoOfEntry-1].rank = -1;
		addBucketNo(&(hashEntry[newNoOfEntry-1]), bucketNo);
	}
		
}



hashEntryPtr ans_addEntryNew(int bucketNo, int *itemSet, int itemSize, int freq, hashPtr hash, int noOfSlot, int sumMinValue, int rank, hashEntryPtr *rankEntry)
{
	hashEntryPtr hashEntry;

	hashEntryPtr tempHashEntry;

	int isSame;

	int newNoOfEntry;

	int hashValue;

	int i, j;

	int r;

	hashEntryPtr entryReturn;

	// searching whether it is in the node

	top_sortItemset(itemSet, itemSize);

	// calculate the hashValue
	hashValue = 0;
	for (i = 0; i < itemSize; i++)
	{
		hashValue += itemSet[i];
	}
	hashValue = hashValue%noOfSlot;
//if (itemSize == 2) printf(" Sorted: <%d %d> Hash Value: %d  ", itemSet[0], itemSet[1], hashValue);
	// check whether this itemset is in the hash
	isSame = 0;
	hashEntry = hash[hashValue].entry;
	for (i = 0; i < hash[hashValue].noOfEntry; i++)
	{
		// check whether the entry is equal to the this itemset
		if (itemSize == hashEntry[i].itemSize)
		{
			isSame = 1;
			for (j = 0; j < itemSize; j++)
			{
				if (hashEntry[i].itemSet[j] != itemSet[j])
				{
					isSame = 0;
					break;
				}
			}

			// if same
			if (isSame == 1)
			{
				hashEntry[i].freq += freq;

				// add
				hashEntry[i].min += freq;
				hashEntry[i].max += freq;
				hashEntry[i].freqNew = freq;

				hashEntry[i].rank = rank;

				entryReturn = &(hashEntry[i]);

				addBucketNo(&(hashEntry[i]), bucketNo);
				break;
			}
		}
	}
//printf("  isSame : %d\n", isSame);
//printf("!!!!!!! isSame = %d\n", isSame);
	if (isSame == 1)
	{
	}
	else
	{
//printf("!!!!!!! noOfEntry = %d\n", hash[hashValue].noOfEntry);
		// does not occur in Hash
		if (hash[hashValue].noOfEntry != 0)
		{
			tempHashEntry = (hashEntryPtr) malloc(sizeof(hashEntryStruct)*hash[hashValue].noOfEntry);
//printf("!!!!!!! %p\n", tempHashEntry[0]);
//printf("!!!!!!! %p\n", tempHashEntry[0].itemSet);
			memcpy(tempHashEntry, hashEntry, sizeof(hashEntryStruct)*hash[hashValue].noOfEntry);
		
			free(hashEntry);
		}

		hash[hashValue].noOfEntry++;
		newNoOfEntry = hash[hashValue].noOfEntry;
		hash[hashValue].entry = (hashEntryPtr) malloc(sizeof(hashEntryStruct)*newNoOfEntry);
		hashEntry = hash[hashValue].entry;
		memset(hashEntry, 0, sizeof(hashEntryStruct)*newNoOfEntry);
	
		if (newNoOfEntry != 1)
		{
			memcpy(hashEntry, tempHashEntry, sizeof(hashEntryStruct)*(newNoOfEntry-1));
			free(tempHashEntry);
		}

		// update the rankEntry
		for (i = 0; i < newNoOfEntry-1; i++)
		{
			r = hashEntry[i].rank;
			if (r >= 0)
			{
				rankEntry[r] = &(hashEntry[i]);
			}
		}

		// add the new at the end
		hashEntry[newNoOfEntry-1].itemSize = itemSize;
		hashEntry[newNoOfEntry-1].itemSet = (int *) malloc(sizeof(int)*itemSize);
		for (i = 0; i < itemSize; i++)
		{
			hashEntry[newNoOfEntry-1].itemSet[i] = itemSet[i];
		}
		hashEntry[newNoOfEntry-1].freq = freq;
		//add
		hashEntry[newNoOfEntry-1].min = freq;
		hashEntry[newNoOfEntry-1].max = freq + sumMinValue; 
		hashEntry[newNoOfEntry-1].freqNew = freq;
		hashEntry[newNoOfEntry-1].rank = rank;
		addBucketNo(&(hashEntry[newNoOfEntry-1]), bucketNo);
		entryReturn = &(hashEntry[newNoOfEntry-1]);

	}
//printf("~~~~~~ point:%p\n", entryReturn);
//printHashEntry(debugFilePtr, entryReturn);
	return entryReturn;
		
}

hashPtr allocateHash(int noOfSlot)
{
	hashPtr hash;

	int i;
	
	hash = (hashPtr) malloc(sizeof(hashStruct)*noOfSlot);
	for (i = 0; i < noOfSlot; i++)
	{
		hash[i].noOfEntry = 0;
		hash[i].entry = NULL;
	}

	return hash;
}

void freeHash(int noOfSlot, hashPtr hash)
{
	int i, j;

	for (i = 0; i < noOfSlot; i++)
	{
		for (j = 0; j < hash[i].noOfEntry; j++)
		{
			free(hash[i].entry[j].itemSet);
		}
		free(hash[i].entry);
	}
}


void findMinMaxNew_entry(hashEntryPtr hashEntry, int noOfBucket, int *minValue, int isBegin)
{
	int *isBucket;

	int i;

	int bucketStartNo;

	isBucket = (int *) malloc(sizeof(int)*noOfBucket);
	memset(isBucket, 0, sizeof(int)*noOfBucket);

	for (i = 0; i < hashEntry->noOfBucket; i++)
	{
		isBucket[hashEntry->bucketNo[i]] = 1;
	}

	hashEntry->min = hashEntry->freq;
	hashEntry->max = hashEntry->freq;
	bucketStartNo = 1-isBegin;
	for (i = bucketStartNo; i < noOfBucket; i++)
	{ 
		if (isBucket[i] == 0)
		{
			hashEntry->max += minValue[i];
		}
	}

	free(isBucket);
}

void findMinMax_entry(hashEntryPtr hashEntry, int noOfBucket, int *minValue)
{
	int *isBucket;

	int i;

	isBucket = (int *) malloc(sizeof(int)*noOfBucket);
	memset(isBucket, 0, sizeof(int)*noOfBucket);

	for (i = 0; i < hashEntry->noOfBucket; i++)
	{
		isBucket[hashEntry->bucketNo[i]] = 1;
	}

	hashEntry->min = hashEntry->freq;
	hashEntry->max = hashEntry->freq;
	for (i = 0; i < noOfBucket; i++)
	{ 
		if (isBucket[i] == 0)
		{
			hashEntry->max += minValue[i];
		}
	}

	free(isBucket);
}

void findMinMax(hashPtr hash, int noOfSlot, int noOfBucket, int *minValue)
{
	int i, j;

	hashEntryPtr hashEntry;


	for (i = 0; i < noOfSlot; i++)
	{
		for (j = 0; j < hash[i].noOfEntry; j++)
		{
			hashEntry = &(hash[i].entry[j]);
			findMinMax_entry(hashEntry, noOfBucket, minValue);
		}
	}

}

void findMinMaxNew(hashPtr hash, int noOfSlot, int noOfBucket, int *minValue, int isBegin)
{
	int i, j;

	hashEntryPtr hashEntry;


	for (i = 0; i < noOfSlot; i++)
	{
		for (j = 0; j < hash[i].noOfEntry; j++)
		{
			hashEntry = &(hash[i].entry[j]);
			findMinMaxNew_entry(hashEntry, noOfBucket, minValue, isBegin);
		}
	}

}

int find_Kmin(hashPtr hash, int noOfSlot, int topK)
{
	int i, j;

	int *startIndex;

	int **index;
	int **value;
	int max = 0;

	int noOfProcess;

	int returnValue;
	int maxIndex;

	int noOfLook;

	startIndex = (int *) malloc(sizeof(int)*noOfSlot);
	index = (int **) malloc(sizeof(int *)*noOfSlot);
	value = (int **) malloc(sizeof(int *)*noOfSlot);

	memset(startIndex, 0, sizeof(int)*noOfSlot);

	// find the greatest value of no. of entry
	for (i = 0; i < noOfSlot; i++)
	{
		index[i] = (int *) malloc(sizeof(int)*hash[i].noOfEntry);
		value[i] = (int *) malloc(sizeof(int)*hash[i].noOfEntry);

		for (j = 0; j < hash[i].noOfEntry; j++)
		{
			index[i][j] = j;
			value[i][j] = hash[i].entry[j].min;
		}

		// sort
		quicksort_i(index[i], value[i], 0, hash[i].noOfEntry-1);
	}

	
	
	noOfLook = 0;
	noOfProcess = 0;
	while (noOfProcess != topK)
	{
		max = 0;
		maxIndex = -1;
		for (i = 0; i < noOfSlot; i++)
		{
			if ((startIndex[i] < hash[i].noOfEntry) && (value[i][startIndex[i]] > max))
			{
				max = value[i][startIndex[i]];
				maxIndex = i;
			}
		}

		if (noOfProcess == 0)
		{
			f1 = max;
		}

		if (maxIndex == -1)
		{
		}
		else
		{
			startIndex[maxIndex]++;
			
			noOfProcess++;

			if (noOfProcess == topK)
			{
				returnValue = max;
			}
		}

		noOfLook++;
		if (noOfLook > topK)
		{
			break;
		}
	}

	// free
	free(startIndex);
	for (i = 0; i < noOfSlot; i++)
	{
		free(index[i]);
		free(value[i]);
	}
	free(index);
	free(value);

	if (noOfLook > topK)
	{
		return -1;
	}
	else
	{
		return returnValue;
	}
}

entryOutPtr getSatisfyResult(hashPtr hash, int noOfSlot, int Kmin, int *noOfOutput)
{
	int i, j, k;

	int count = 0;

	int size;

	entryOutPtr returnValue;

	(*noOfOutput) = 0;
	for (i = 0; i < noOfSlot; i++)
	{
		for (j = 0; j < hash[i].noOfEntry; j++)
		{
			if (hash[i].entry[j].max >= Kmin)
			{
				(*noOfOutput)++;
			}
		}
	}

	//returnValue = (entryOutPtr *) malloc(sizeof(entryOutStruct)*(*noOfOutput));
	//returnValue = (entryOutPtr *) malloc(sizeof(entryOutPtr)*L);
	//for (i  = 0; i < L; i++)
	//{
	//	returnValue[i] = (entryOutPtr) malloc(sizeof(entryOutStruct)*noOfOutput[i]);
	//}
	returnValue = (entryOutPtr) malloc(sizeof(entryOutStruct)*(*noOfOutput));

	for (i = 0; i < noOfSlot; i++)
	{
		for (j = 0; j < hash[i].noOfEntry; j++)
		{
			if (hash[i].entry[j].max >= Kmin)
			{
				size = hash[i].entry[j].itemSize;
				returnValue[count].itemsetSize = size;
				returnValue[count].item = (int *) malloc(sizeof(int)*size);
				for (k = 0; k < size; k++)
				{
					returnValue[count].item[k] = hash[i].entry[j].itemSet[k];
				}
				returnValue[count].min = hash[i].entry[j].min;
				returnValue[count].max = hash[i].entry[j].max;
				count++;
			}
		}
	}

	return returnValue;
}

int calculateDeltaMaxBound(int topK, double theta)
{
	int returnValue;

	// truncating
	returnValue = (int) ( f1/(2*pow(topK,theta)*(1.0+1.0/epsilon)) );

	return returnValue;
}

int calculateDeltaMax(int smallestMinValue, int sumMinValue, int curMinValue)
{
	int returnValue;

	if (smallestMinValue < curMinValue)
	{
		//returnValue = sumMinValue-smallestMinValue+curMinValue;
		returnValue = sumMinValue-smallestMinValue+(curMinValue-1);
	}
	else
	{
		returnValue = sumMinValue;
	}

	return returnValue;
}

// updating returnValue
void doStoreMore(entryPtr returnValue, int *returnK, int topK, double theta, int K1, int smallestMinValue, int sumMinValue, int *curMinValue)
{
	int bound;
	int delta;

	delta = calculateDeltaMax(smallestMinValue, sumMinValue, (*curMinValue));
	bound = calculateDeltaMaxBound(topK, theta);
//printf("####### %d, %d \n", (*returnK), K1);

	if ((*returnK) < K1)
	{
		while (delta > bound)
		{
			(*returnK)++;

			(*curMinValue) = returnValue[(*returnK)-1].count;
			delta = calculateDeltaMax(smallestMinValue, sumMinValue, (*curMinValue));

			// prevent out-of-bound
			if ((*returnK) >= K1)
			{
				break;
			}
		}

		if ((*returnK) < K1)
		{
			while (((*returnK)-1 >= 0) && (returnValue[(*returnK)].count == returnValue[(*returnK)-1].count))
			{
				(*returnK)++;

				(*curMinValue) = returnValue[(*returnK)-1].count;
				//delta = calculateDeltaMax(smallestMinValue, sumMinValue, (*curMinValue));

				// prevent out-of-bound
				if ((*returnK) >= K1)
				{
					break;
				}
			}
		}
	}
}

entryPtr getSatisfyResultNewMemoryConstraint(int Kmin, hashEntryPtr *rankEntry, int r0, int K1, int *noOfOutput)
{
	int i, k;

	int no;
	entryPtr returnValue;

	int size;

	if (r0 > K1)
	{
		r0 = K1;
	}

//
//printf("**************************************1 in getSatisfyResultNewMemoryConstraint\n");
//printRankEntry(debugFilePtr, rankEntry, K1);
//printf("***************************************2 in getSatisfyResultNewMemoryConstraint\n");
	no = 0;
	for (i = r0-1; i >=0; i--)
	{
		if  ((rankEntry[i] != NULL) && (rankEntry[i]->max >= Kmin) && (rankEntry[i]->freqNew != 0))
		{
			no = i+1;
			break;
		}
	}
//printf("^^^^^^^^^^^^^^^^^ no : %d\n", no);
	if (no > 0)
	{
		(*noOfOutput) = no;

		// malloca more for reservation purpose
		returnValue = (entryPtr) malloc(sizeof(entry)*K1);
		//for (i = 0; i < no; i++)
		for (i = 0; i < K1; i++)
		{
//printf("^^^^^^^^^^^^^^^^^ i : %d\n", i);
//printf("^^^^^^^^^^^^^^^^^ 5.1\n");
			size = rankEntry[i]->itemSize;
			returnValue[i].itemsetSize = size;
			returnValue[i].item = (int *) malloc(sizeof(int)*size);
//printf("^^^^^^^^^^^^^^^^^ 5.2 (size: %d)\n", size);
			for (k = 0; k < size; k++)
			{
//printf("^^^^^^^^^^^^^^^^^ 5.2.1\n");
				returnValue[i].item[k] = rankEntry[i]->itemSet[k];
//printf("^^^^^^^^^^^^^^^^^ 5.2.2\n");
			}
//printf("^^^^^^^^^^^^^^^^^ 5.3\n");
			returnValue[i].count = rankEntry[i]->freqNew;
//printf("^^^^^^^^^^^^^^^^^ 5.4\n");					
		}
	}
	else
	{
		(*noOfOutput) = 0;
		returnValue = NULL;
	}

	return returnValue;
}

entryPtr getSatisfyResultNew(hashPtr hash, int noOfSlot, int Kmin, int *noOfOutput)
{
	int i, j, k;

	int count = 0;

	int size;

	entryPtr returnValue;

	(*noOfOutput) = 0;
	for (i = 0; i < noOfSlot; i++)
	{
		for (j = 0; j < hash[i].noOfEntry; j++)
		{
			if ((hash[i].entry[j].max >= Kmin) && (hash[i].entry[j].freqNew != 0))
			{
				(*noOfOutput)++;
			}
		}
	}

	returnValue = (entryPtr) malloc(sizeof(entry)*(*noOfOutput));
	//returnValue = (entryOutPtr *) malloc(sizeof(entryOutStruct)*(*noOfOutput));
	//returnValue = (entryPtr *) malloc(sizeof(entryPtr)*L);
	//for (i  = 0; i < L; i++)
	//{
	//	returnValue[i] = (entryPtr) malloc(sizeof(entry)*noOfOutput[i]);
	//}

	for (i = 0; i < noOfSlot; i++)
	{
		for (j = 0; j < hash[i].noOfEntry; j++)
		{
			if ((hash[i].entry[j].max >= Kmin) && (hash[i].entry[j].freqNew != 0))
			{
				size = hash[i].entry[j].itemSize;
				returnValue[count].itemsetSize = size;
				returnValue[count].item = (int *) malloc(sizeof(int)*size);
				for (k = 0; k < size; k++)
				{
					returnValue[count].item[k] = hash[i].entry[j].itemSet[k];
				}
				returnValue[count].count = hash[i].entry[j].freqNew;
				count++;
			}
		}
	}

	return returnValue;
}

void printHashEntry(FILE *filePtr, hashEntryPtr en)
{
	int i;

	//printf("  ");
//	fprintf(filePtr, "  ");
//printf("(%p)", en->itemSet);
	for (i = 0; i < en->itemSize; i++)
	{
		//printf("%d ", en->itemSet[i]);
//		fprintf(filePtr, "%d ", en->itemSet[i]);
	}
	//printf("\n");
	//printf("   freq    : %d\n", en->freq);
	//printf("   freqNew : %d\n", en->freqNew);
	//printf("   bucketNo (%d): ", en->noOfBucket);
//	fprintf(filePtr, "\n");
//	fprintf(filePtr, "   freq    : %d\n", en->freq);
//	fprintf(filePtr, "   freqNew : %d\n", en->freqNew);
//	fprintf(filePtr, "   bucketNo (%d): ", en->noOfBucket);
	for (i = 0; i < en->noOfBucket; i++)
	{
		//printf("%d ", en->bucketNo[i]);
//		fprintf(filePtr, "%d ", en->bucketNo[i]);
	}
	//printf("\n");
	//printf("   min: %d\n", en->min);
	//printf("   max: %d\n", en->max);
//	fprintf(filePtr, "\n");
//	fprintf(filePtr, "   min: %d\n", en->min);
//	fprintf(filePtr, "   max: %d\n", en->max);
			

}

void printHash(FILE *filePtr, hashPtr hash, int noOfSlot)
{
	int i, j;

	hashEntryPtr temp;

	for (i = 0; i < noOfSlot; i++)
	{
		//printf(" Slot %d\n", i);
		//printf(" ---------\n");
		fprintf(filePtr, " Slot %d\n", i);
		fprintf(filePtr, " ---------\n");

		for (j = 0; j < hash[i].noOfEntry; j++)
		{
			temp = &(hash[i].entry[j]);
			 
			printHashEntry(filePtr, temp);
		}

	}
}

void printRankEntry(FILE *filePtr, hashEntryPtr *rankEntry, int noOfK)
{
	int i;

	for (i = 0; i < noOfK; i++)
	{
		printf("   Rank %d\n", i);
		printf("   --------\n");

		fprintf(filePtr, "   Rank %d\n", i);
		fprintf(filePtr, "   --------\n");

		printf("!!!!!! pointer    : %p\n", rankEntry[i]);
		printf("!!!!!! in pointer : %p\n", rankEntry[i]->itemSet);
		printHashEntry(filePtr, rankEntry[i]);
	}
}

entryOutPtr *findItemset(entryPtr **bucket, int noOfBucket, int **noOfEntry, int topK, int L, int *returnK)
{
	entryOutPtr *returnValue;

	hashPtr *hash;

	int **minValue;

	int i, j, k;

	int Kmin;

	// allocate memory for hash
	hash = (hashPtr *) malloc(sizeof(hashPtr)*L);
	for (i = 0; i < L; i++)
	{
		hash[i] = allocateHash(noOfSlot);
	}

	// add the entries in the sliding window into the hash
	for (i = 0; i < noOfBucket; i++)
	{
		for (k = 0; k < L; k++)
		{
			for (j = 0; j < noOfEntry[i][k]; j++)
			{
				ans_addEntry(i, bucket[i][k][j].item, bucket[i][k][j].itemsetSize, bucket[i][k][j].count, hash[k], noOfSlot);
			}
		}
	}
	
	// find the min. value of each bucket
	minValue = (int **) malloc(sizeof(int *)*L);
	//minValue = (int *) malloc(sizeof(int)*noOfBucket);
	for (i = 0; i < L; i++)
	{
		minValue[i] = (int *) malloc(sizeof(int)*noOfBucket);
		memset(minValue[i], 0, sizeof(int)*noOfBucket);
		for (k = 0; k < noOfBucket; k++)
		{
			if (noOfEntry[k][i] == 0)
			{
				minValue[i][k] = 0;
			}
			else
			{
				minValue[i][k] = bucket[k][i][noOfEntry[k][i]-1].count-1;
			}
		}
	}

	// find the min. and max of each entry
	for (i = 0; i < L; i++)
	{
		findMinMax(hash[i], noOfSlot, noOfBucket, minValue[i]);
	}

	// print hash
	printf("Printing hash...\n");
	fprintf(debugFilePtr, "Printing hash...\n");
	for (i = 0; i < L; i++)
	{
		//printf("  Size %d\n", i);
		//printf("  ~~~~~~\n");
		fprintf(debugFilePtr, "  Size %d\n", i);
		fprintf(debugFilePtr, "  ~~~~~~\n");
		printHash(debugFilePtr, hash[i], noOfSlot);
	}


	// get the result where max >= Kmin
	returnValue = (entryOutPtr *) malloc(sizeof(entryOutPtr)*L);
	for (i = 0; i < L; i++)
	{
		// sort the entries in descending order of minValue (with topK)
		Kmin = find_Kmin(hash[i], noOfSlot, topK);

		if (Kmin == -1)
		{
			// do nothing

			returnK[i] = 0;
		}
		else
		{
			returnValue[i] = getSatisfyResult(hash[i], noOfSlot, Kmin, &(returnK[i]));
		}
	}

	// free the hash
	//void freeHash(int noOfSlot, hashPtr hash)
	for (i = 0; i < L; i++)
	{
		freeHash(noOfSlot, hash[i]);
		free(hash[i]);
	}
	free(hash);

	free(minValue);

	//returnValue = NULL;

	return returnValue;
}

/*
entryPtr transformOut2Entry(entryOutPtr out, int *noOfEntry)
{
	entryPtr returnValue;

	int i;

	returnValue = (entryPtr) malloc(sizeof(entry)*noOfEntry);

	for (i = 0; i < noOfEntry; i++)
	{
		addEntry(&returnValue, i, out[i].item, out[i].itemsetSize, out[i].
	}

	return returnValue;
}
*/

entryPtr *findNewBucket(char *filename, int startIndex, int endIndex, entryPtr **bucket, int curNoOfBucket, int noOfBucket, int **noOfEntry, int topK, int L, double *theta,int *returnK, int bucketSize)
{
	entryPtr *returnValue;

	entryPtr *newBucket;

	hashPtr *hash;

	int **minValue;

	int i, j, k;

	int Kmin;

	int *sumMinValue;

	hashEntryPtr **rankEntry;

	// dummy
	//int K = 4;
	int K1;
	int r0;

	int *returnKOld;

	int bucketStartNo;
	int curMinValue;

	int *smallestMinValue;

	int isBegin = 1;

	if (curNoOfBucket < noOfBucket)
	{
		isBegin = 1;
	}
	else
	{
		isBegin = 0;
	}

	smallestMinValue = (int *) malloc(sizeof(int)*L);
//printf("~~~~1.1\n");
	// allocate memory for hash
	hash = (hashPtr *) malloc(sizeof(hashPtr)*L);
	for (i = 0; i < L; i++)
	{
		hash[i] = allocateHash(noOfSlot);
	}
	//hash = allocateHash(noOfSlot);

	// add the entries in the sliding window into the hash
	for (i = 1-isBegin; i < curNoOfBucket; i++)
	{
		for (k = 0; k < L; k++)
		{
			for (j = 0; j < noOfEntry[i][k]; j++)
			{
				ans_addEntry(i, bucket[i][k][j].item, bucket[i][k][j].itemsetSize, bucket[i][k][j].count, hash[k], noOfSlot);
			}
		}
	}
//printf("~~~~1.2\n");	
	// find the min. value of each bucket
	minValue = (int **) malloc(sizeof(int *)*L);
	//minValue = (int *) malloc(sizeof(int)*curNoOfBucket);
	for (i = 0; i < L; i++)
	{
		minValue[i] = (int *) malloc(sizeof(int)*noOfBucket);
		memset(minValue[i], 0, sizeof(int)*noOfBucket);
		for (k = 0; k < noOfBucket; k++)
		{
			if (noOfEntry[k][i] == 0)
			{
				minValue[i][k] = 0;
			}
			else
			{
				minValue[i][k] = bucket[k][i][noOfEntry[k][i]-1].count-1;
			}
		}
	}

//for (i = 0; i < L; i++)
//{
//for (j = 0; j < noOfBucket; j++)
//printf("^^^^^^^^^ (%d, %d) = %d\n", i, j, minValue[i][j]);
//}
//printf("~~~~1.3\n");
	// find the min. and max of each entry
	for (i = 0; i < L; i++)
	{
		findMinMaxNew(hash[i], noOfSlot, curNoOfBucket, minValue[i], isBegin);
	}

	// find top r_0 in new bucket
	r0 = findOptimalRank(topK, noOfBucket, theta[0], noOfBucket*bucketSize);
	K1 = 100*r0;

	//entryPtr processBOMO(char *configFilename, int startIndex, int bucketSize, int topK, int K, int *noOfTopK)

	newBucket = processBOMO(filename, startIndex, endIndex-startIndex+1, K1, L, returnK);

	//printf("** in findNewBucket(before)\n");
	fprintf(debugFilePtr, "in findNewBucket\n");
	printBucket(debugFilePtr, newBucket, returnK, L);
//printf("~~~~1.4\n");
	// insert it into hash
	//sumMinValue = 0;
	sumMinValue = (int *) malloc(sizeof(int)*L);
	memset(sumMinValue, 0, sizeof(int)*L);
	rankEntry = (hashEntryPtr **) malloc(sizeof(hashEntryPtr *)*L);
	for (k = 0; k < L; k++)
	{
		bucketStartNo = 1-isBegin;
		smallestMinValue[k] = minValue[k][bucketStartNo];
		for (i = bucketStartNo; i < curNoOfBucket; i++)
		{
			
			sumMinValue[k] += minValue[k][i];

			if (minValue[k][i] < smallestMinValue[k])
			{
				smallestMinValue[k] = minValue[k][i];
			}
			
		}
		if (returnK[k] > 0)
		{
			rankEntry[k] = (hashEntryPtr *) malloc(sizeof(hashEntryPtr)*returnK[k]);
			memset(rankEntry[k], 0, sizeof(hashEntryPtr)*returnK[k]);
			for (i = 0; i < returnK[k]; i++)
			{
// sth wrong
//if (newBucket[k][i].itemsetSize == 2)
//printf("(%d %d)\n", newBucket[k][i].item[0], newBucket[k][i].item[1]);
//printf("!!!!!!! i = %d\n", i);

				rankEntry[k][i] = ans_addEntryNew(curNoOfBucket, newBucket[k][i].item, newBucket[k][i].itemsetSize, newBucket[k][i].count, hash[k], noOfSlot, sumMinValue[k], i, rankEntry[k]);
//if ((curNoOfBucket == 2) && (k >= 1) && (i >= 0))
//{
//printf("~~~~RAYRAY (BEGIN)(1,0) ~~~~\n");
//printHashEntry(debugFilePtr, rankEntry[1][0]);
//printf("~~~~RAYRAY (END) (1,0)~~~~\n");
//}
//printf("~~~~RAY (BEGIN)(k,i)=(%d, %d) (%p)~~~~\n", k, i, rankEntry[k][i]);
//printHashEntry(debugFilePtr, rankEntry[k][i]);
//printf("~~~~RAY (END) (k,i)=(%d, %d)~~~~\n", k, i);
			}


//if (rankEntry[1] != NULL)
//if (rankEntry[1][0] != NULL)
//if (&(rankEntry[1][0]) == 0xa0433f8)
//{
//printf("~~~~RAY22 (BEGIN)(k,i)=(1, 0) ~~~~\n");
//printf("  %p\n", rankEntry[1][0]);
//printf("  %p\n", rankEntry[1][0]->itemSet);
//printf("~~~~RAY22 (END) (k,i)=(1, 0)~~~~\n");
//}


//printf("***************1(Size %d)(returnK[k]:%d)*********************1 in findNewBucket\n",k,returnK[k]);
//printRankEntry(debugFilePtr, rankEntry[k], returnK[k]);
//printf("***************2(Size %d)(returnK[k]:%d)***********************2 in findNewBucket\n",k,returnK[k]);
		

		}
	}


//for (k = 0; k < L; k++)
//{
//for (i = 0; i < returnK[k]; i++)
//{
//printf("~~~~RAY (BEGIN)(k,i)=(%d, %d) ~~~~\n", k, i);
//printHashEntry(debugFilePtr, rankEntry[k][i]);
//printf("~~~~RAY (END) (k,i)=(%d, %d)~~~~\n", k, i);
//}
//}
//printf("~~~~1.5\n");	

//printf("################### BEGIN #######################3\n");
//printHash(debugFilePtr, hash[1], noOfSlot);
//printf("################### END #########################3\n");

	// get the result where max >= Kmin
	returnValue = (entryPtr *) malloc(sizeof(entryPtr)*L);
	returnKOld = (int *) malloc(sizeof(int)*L);
	memcpy(returnKOld, returnK, sizeof(int)*L);
	for (i = 0; i < L; i++)
	{
//printf("~~~~~~~ i = %d\n", i);
		// sort the entries in descending order of minValue (with topK)
		// internally calculate f1
		Kmin = find_Kmin(hash[i], noOfSlot, topK);
//printf("&&&&&&&&&&&& %d - Kmin = %d\n", i, Kmin);
//printf("~~~~~~~ Kmin = %d\n", Kmin);
		if (Kmin == -1)
		{ 
			// do nothing

			returnK[i] = 0;
		}
		else
		{
			if (returnKOld[i] > 0)
			{
//printf("~~~~~1.5.1.1\n");
				//returnValue[i] = getSatisfyResultNew(hash[i], noOfSlot, Kmin, &(returnK[i]));
				//entryPtr getSatisfyResultNewMemoryConstraint(int Kmin, hashEntryPtr *rankEntry, int r0, int K1, int *noOfOutput)
if (k == 3)
{
	printf("hello\n");
}
				returnValue[i] = getSatisfyResultNewMemoryConstraint(Kmin, rankEntry[i], r0, returnKOld[i], &(returnK[i]));
//printf("~~~~~1.5.1.5\n");
				if (returnK[i] > 0)
				{
//printf("~~~~~~~~~~~~~~ i : %d\n", i);
//printf("~~~~~~~~~~~~~~ returnK[i] : %d\n", returnK[i]);
					curMinValue =  returnValue[i][returnK[i]-1].count;
//printf("~~~~~1.5.1.7\n");
				}
				else
				{
					curMinValue = 0;
				}
				// make the accuracy bound
//printf("~~~~~1.5.2\n");
				doStoreMore(returnValue[i], &(returnK[i]), topK, theta[i], returnKOld[i], smallestMinValue[i], sumMinValue[i], &curMinValue);
//printf("~~~~~1.5.3\n");
			}
			else
			{
				returnValue[i] = NULL;
			}
		}
	}


//printf("~~~~1.6\n");	

//	printf("** in findNewBucket(after)\n");
//	fprintf(debugFilePtr, "in findNewBucket\n");
//	printBucket(debugFilePtr, returnValue, returnK, L);

//printf("~~~~1.7\n");
	// free rankEntry
	for (k = 0; k < L; k++)
	{
		// the entry is free in the hash free
		if (returnKOld[k] > 0)
		{
			//free(rankEntry[k]);
		}
	}
//printf("~~~~1.8\n");
	//free(rankEntry);
//printf("~~~~1.9\n");
	free(returnKOld);
//printf("~~~~1.10\n");
	// free the hash
	//void freeHash(int noOfSlot, hashPtr hash)
	for (i = 0; i < L; i++)
	{
		freeHash(noOfSlot, hash[i]);
		free(hash[i]);
	}
	free(hash);
//printf("~~~~1.11\n");
	free(minValue);
//printf("~~~~1.12\n");
	free(smallestMinValue);

	free(sumMinValue);



	//returnValue = NULL;

	return returnValue;
}

int evaluateNoOfEntryBucket(entryPtr **bucket, int noOfBucket, int L, int **noOfEntry)
{
	int returnValue;

	int i, j;

	returnValue = 0;
	for (i = 0; i < noOfBucket; i++)
	{
		for (j = 0; j < L; j++)
		{
			returnValue += noOfEntry[i][j];
		}
	}

	return returnValue;
}

entryOutPtr *processData(char *filename, int noOfTrans, int noOfItem, int noOfBucket, int bucketSize, int currBucketNo, int topK, int L, double *theta, int *returnK)
{
	entryOutPtr *returnValue;
	entryPtr **bucket;

	entryPtr *newBucket;

	int startIndex, endIndex;

	int curNoOfBucket;

	int i, j, k;

	int *tempTopK;
	entryPtr *tempReturnValue;
	int tempBucketSize;
	int tempStartIndex;

#ifndef _WIN32
 float  userTime, sysTime;
 struct rusage myTime1, myTime2;
 struct rusage myTime3, myTime4;
 FILE *timeFilePtr;
 FILE *timeFilePtr2;
#endif
	


	noOfEntry = (int **) malloc(sizeof(int *)*noOfBucket);
	for (i = 0; i < noOfBucket; i++)
	{
		noOfEntry[i] = (int *) malloc(sizeof(int)*L);
		memset(noOfEntry[i], 0, sizeof(int)*L);
	}

	bucket = (entryPtr **) malloc(sizeof(entryPtr *)*noOfBucket);
	for (i = 0; i < noOfBucket; i++)
	{
		bucket[i] = (entryPtr *) malloc(sizeof(entryPtr)*L);
	}
	//bucket = (entryPtr *) malloc(sizeof(entryPtr)*noOfBucket);

	// find the first bucket
	startIndex = 0;
	endIndex = bucketSize-1;
	
	curNoOfBucket = 0;
#ifndef _WIN32
 getrusage(RUSAGE_SELF,&myTime1);
 getrusage(RUSAGE_SELF,&myTime3);

 	timeFilePtr2 = (FILE *) fopen("time2.txt", "w");
#endif


	printf("*************************** Bucket 0 ***************************\n");
	fprintf(debugFilePtr, "****** Bucket 0...\n");
	newBucket = createNewBucket(filename, startIndex, endIndex, topK, L, theta, bucket, noOfEntry, curNoOfBucket, noOfBucket, returnK, bucketSize);
	bucket[0] = newBucket;
	memcpy(noOfEntry[0], returnK, sizeof(int)*L);

#ifndef _WIN32
 getrusage(RUSAGE_SELF,&myTime4);

 userTime =
     		((float) (myTime4.ru_utime.tv_sec  - myTime3.ru_utime.tv_sec)) +
       		((float) (myTime4.ru_utime.tv_usec - myTime3.ru_utime.tv_usec)) * 1e-6;
 sysTime =
       		((float) (myTime4.ru_stime.tv_sec  - myTime3.ru_stime.tv_sec)) +
       		((float) (myTime4.ru_stime.tv_usec - myTime3.ru_stime.tv_usec)) * 1e-6;

	fprintf(timeFilePtr2, "0\t%f\n", userTime);

  getrusage(RUSAGE_SELF,&myTime3);
#endif

	curNoOfBucket = 1;

	// print the bucketInfo
	//void printBucket(FILE *filePtr, entryPtr bucket, int noOfEntry)
	fprintf(debugFilePtr, "  Bucket 0\n");
	printBucket(debugFilePtr, newBucket, returnK, L);
	
	// find the second bucket or later buckets
	printf("Finding the second buckets or later buckets...\n");
	for (i = 1; i <= currBucketNo; i++)
	{
		printf("*************************** Bucket %d ***************************\n", i);
		fprintf(debugFilePtr, "****** Bucket %d...\n", i);
		startIndex = bucketSize*i;
		endIndex = bucketSize*(i+1)-1;
//printf("@@@@ 1.1\n");
		newBucket = createNewBucket(filename, startIndex, endIndex, topK, L, theta, bucket, noOfEntry, curNoOfBucket, noOfBucket, returnK, bucketSize);
//printf("@@@@ 1.2\n");
		if (curNoOfBucket < noOfBucket)
		{
			memcpy(noOfEntry[curNoOfBucket], returnK, sizeof(int)*L);
			//memcpy(noOfEntry, returnK, sizeof(int)*L);
			//noOfEntry[curNoOfBucket] = returnK;
		}

		// print the bucketInfo
		//void printBucket(FILE *filePtr, entryPtr bucket, int noOfEntry)
		printf("----- Bucket No. %d (count from the start)\n", i);
		fprintf(debugFilePtr, "  Bucket %d\n", i);
		printBucket(debugFilePtr, newBucket, returnK, L);
	

		printf("#### Before Switching...\n");
		fprintf(debugFilePtr, "#### Before Switching...\n");
		// print the bucketInfo
		//void printBucket(FILE *filePtr, entryPtr bucket, int noOfEntry)
		for (j = 0; j < curNoOfBucket; j++)
		{
			printf("   ### Bucket %d\n", j);
			fprintf(debugFilePtr, "   ### Bucket %d\n", j);
			printBucket(debugFilePtr, bucket[j], noOfEntry[j], L);
		}
		switchBucket(bucket, curNoOfBucket, noOfBucket, newBucket, returnK, L, noOfEntry);

		if (curNoOfBucket < noOfBucket)
		{
			curNoOfBucket++;
		}

		

		printf("#### After Switching...\n");
		fprintf(debugFilePtr, "#### After Switching...\n");

		// print the bucketInfo
		//void printBucket(FILE *filePtr, entryPtr bucket, int noOfEntry)
		for (j = 0; j < curNoOfBucket; j++)
		{
			printf("   ### Bucket %d\n", j);
			fprintf(debugFilePtr, "   ### Bucket %d\n", j);
			printBucket(debugFilePtr, bucket[j], noOfEntry[j], L);
		}

#ifndef _WIN32
 getrusage(RUSAGE_SELF,&myTime4);

 userTime =
     		((float) (myTime4.ru_utime.tv_sec  - myTime3.ru_utime.tv_sec)) +
       		((float) (myTime4.ru_utime.tv_usec - myTime3.ru_utime.tv_usec)) * 1e-6;
 sysTime =
       		((float) (myTime4.ru_stime.tv_sec  - myTime3.ru_stime.tv_sec)) +
       		((float) (myTime4.ru_stime.tv_usec - myTime3.ru_stime.tv_usec)) * 1e-6;

	fprintf(timeFilePtr2, "%d\t%f\n", i, userTime);

  getrusage(RUSAGE_SELF,&myTime3);
#endif

	}

	// find the itemsets
	//findItemset(entryPtr *bucket, int noOfBucket, int topK, int *returnK)
	printf("Finding itemsets...\n");
	returnValue = findItemset(bucket, curNoOfBucket, noOfEntry, topK, L, returnK);

#ifndef _WIN32
 getrusage(RUSAGE_SELF,&myTime2);
#endif

#ifndef _WIN32

 /* output running time ----------------------------*/
 printf("build tree time:\n");
 userTime =
     		((float) (myTime2.ru_utime.tv_sec  - myTime1.ru_utime.tv_sec)) +
       		((float) (myTime2.ru_utime.tv_usec - myTime1.ru_utime.tv_usec)) * 1e-6;
 sysTime =
       		((float) (myTime2.ru_stime.tv_sec  - myTime1.ru_stime.tv_sec)) +
       		((float) (myTime2.ru_stime.tv_usec - myTime1.ru_stime.tv_usec)) * 1e-6;

 printf("User time : %f seconds\n",userTime);
 printf("System time : %f seconds\n\n",sysTime);

 	timeFilePtr = (FILE *) fopen("time.txt", "w");
	fprintf(timeFilePtr, "Data Stream\n");
	fprintf(timeFilePtr, "-----------\n");
	fprintf(timeFilePtr, "User time : %f seconds\n",userTime);
    fprintf(timeFilePtr, "System time : %f seconds\n\n",sysTime);
#endif

#ifndef _WIN32
 getrusage(RUSAGE_SELF,&myTime1);
#endif
	// find in BOMO
	printf("Finding BOMO...\n");
	tempTopK = (int *)  malloc(sizeof(int)*L);
	memset(tempTopK, 0, sizeof(int)*L);
	tempBucketSize = curNoOfBucket*bucketSize;
	tempStartIndex = startIndex - (curNoOfBucket-1)*bucketSize;
	//entryPtr *processBOMO(char *configFilename, int startIndex, int bucketSize, int topK, int L, int *noOfTopK)
	tempReturnValue = processBOMO(filename, tempStartIndex, tempBucketSize, topK, L, tempTopK);
	fprintf(debugFilePtr, "~~~~ BOMO Result ~~~~~~~\n");
	fprintf(countFilePtr, "Top %d\n", L);
	for (i = 0; i < L; i++)
	{
		//printf("********** %d: %d\n", i, tempTopK[i]);
		fprintf(debugFilePtr, "   Size %d: %d\n", i, tempTopK[i]);
		for (j = 0; j < tempTopK[i]; j++)
		{
			fprintf(debugFilePtr, "      ");
			for (k = 0; k <= i; k++)
			{
				fprintf(debugFilePtr, "%d ", tempReturnValue[i][j].item[k]);
			}
			fprintf(debugFilePtr, "\t%d\n", tempReturnValue[i][j].count);

			if (j == tempTopK[i]-1)
			{
				fprintf(countFilePtr, "Size %d\n", i);
				fprintf(countFilePtr, "%d\n", tempReturnValue[i][j].count);
			}
		}
	}
#ifndef _WIN32
 getrusage(RUSAGE_SELF,&myTime2);
#endif

 
#ifndef _WIN32

 /* output running time ----------------------------*/
 printf("build tree time:\n");
 userTime =
     		((float) (myTime2.ru_utime.tv_sec  - myTime1.ru_utime.tv_sec)) +
       		((float) (myTime2.ru_utime.tv_usec - myTime1.ru_utime.tv_usec)) * 1e-6;
 sysTime =
       		((float) (myTime2.ru_stime.tv_sec  - myTime1.ru_stime.tv_sec)) +
       		((float) (myTime2.ru_stime.tv_usec - myTime1.ru_stime.tv_usec)) * 1e-6;

 printf("User time : %f seconds\n",userTime);
 printf("System time : %f seconds\n\n",sysTime);

 	
	fprintf(timeFilePtr, "BOMO\n");
	fprintf(timeFilePtr, "-----------\n");
	fprintf(timeFilePtr, "User time : %f seconds\n",userTime);
    fprintf(timeFilePtr, "System time : %f seconds\n\n",sysTime);
	fclose(timeFilePtr);
#endif
	// print result
	fprintf(debugFilePtr, "============FALSE POSITIVE(BEGIN)==============\n");
	for (i = 0; i < L; i++)
	{
		fprintf(debugFilePtr, "   Size %d - %d\n", i, returnK[i]-tempTopK[i]);
	}
	fprintf(debugFilePtr, "============FALSE POSITIVE(END)==============\n");


	// count the bucket
	//memoryUsage = int evaluateNoOfEntryBucket(entryPtr **bucket, int noOfBucket, int L, int **noOfEntry)
	memoryUsage = evaluateNoOfEntryBucket(bucket, noOfBucket, L, noOfEntry);
	printf("Memory Usage : %d\n", memoryUsage);
	fprintf(debugFilePtr, "Memory Usage : %d\n", memoryUsage);

	return returnValue;
}

void printTopOutput(FILE *filePtr, entryOutPtr *output, int *noOfOut, int L)
{
	int i, j, k;

	
	for (k = 0; k < L; k++)
	{
		printf("~~~ Size %d ~~~~\n", k);
		fprintf(filePtr, "~~~ Size %d ~~~~\n", k);
		printf("There are %d outputs.\n", noOfOut[k]);
		fprintf(filePtr, "There are %d outputs.\n", noOfOut[k]);

		fprintf(countFilePtr, "Size %d\n",k);
		fprintf(countFilePtr, "%d\n",noOfOut[k]);
		for (i = 0; i < noOfOut[k]; i++)
		{
			printf(" *** Output %d\n  ", i);
			fprintf(filePtr, " *** Output %d\n  ", i);
			for (j = 0; j < output[k][i].itemsetSize; j++)
			{
				printf("%d ", output[k][i].item[j]);
				fprintf(filePtr, "%d ", output[k][i].item[j]);

				fprintf(countFilePtr, "%d ", output[k][i].item[j]);
			}
			printf("\tmax: %d and min: %d\n", output[k][i].max, output[k][i].min);
			fprintf(filePtr, "\tmax: %d and min: %d\n", output[k][i].max, output[k][i].min);

			fprintf(countFilePtr, "\n");
		}
	}
}

entryPtr *divideData(transPtr *data, int noOfTrans, int noOfItem, int noOfBucket, int E, int *noOfBucketEntry, int *uncount)
{
	entryPtr *returnValue;

	int bucketSize;
	int index;

	int i, j, k;

	int *count;

	int noOfEntry;
	

	bucketSize = noOfTrans/noOfBucket;

	count = (int *) malloc(sizeof(int)*noOfItem);
	memset(count, 0, sizeof(int)*noOfItem);

	returnValue = (entryPtr *) malloc(sizeof(entryPtr)*noOfBucket);
	

	for (i = 0; i < noOfBucket; i++)
	{
		memset(count, 0, sizeof(int)*noOfItem);
		// find the freq. of item
		for (j = 0; j < bucketSize; j++)
		{
			index = i*bucketSize + j;

			for (k = 0; k < data[index]->noOfItem; k++)
			{
				count[data[index]->item[k]]++;
			}
		}

		// find the frequent item
		noOfEntry = 0;
		for (j = 0; j < noOfItem; j++)
		{
			if (count[j] >= E)
			{
				noOfEntry++;
			}
			else
			{
				(*uncount)++;
			}
		}

		noOfBucketEntry[i] = noOfEntry;
		returnValue[i] = (entryPtr) malloc(sizeof(entry)*noOfEntry);
printf("   Bucket %d: no. of entries : %d\n", i, noOfEntry);
		noOfEntry = 0;
		for (j = 0; j < noOfItem; j++)
		{
			if (count[j] >= E)
			{
				returnValue[i][noOfEntry].count = count[j];
				returnValue[i][noOfEntry].itemsetSize = 1;
				returnValue[i][noOfEntry].item = (int *) malloc(sizeof(int)*1);
				returnValue[i][noOfEntry].item[0] = j;
				noOfEntry++;
			}
		}
	}

	return returnValue;
}


// probBucket : [0..noOfBucket]
int **analyzeBucket(entryPtr *bucket, int noOfBucket, int noOfItem, int *noOfBucketEntry, int uncount, double *probBucket)
{
	int **returnValue;
	int *bucketCount;
	int *totalCount;

	int *b_noOfEntry;
	int *b_freq;

	int total;

	int i, j;

	returnValue = (int **) malloc(sizeof(int *)*(noOfBucket+1));
	for (i = 0; i < noOfBucket+1; i++)
	{
		returnValue[i] = (int *) malloc(sizeof(int)*noOfBucket);
		memset(returnValue[i], 0, sizeof(int)*noOfBucket);
	}
	
	bucketCount = (int *) malloc(sizeof(int)*noOfItem);
	totalCount = (int *) malloc(sizeof(int)*noOfItem);
	memset(bucketCount, 0, sizeof(int)*noOfItem);
	memset(totalCount, 0, sizeof(int)*noOfItem);

	b_noOfEntry = (int *) malloc(sizeof(int)*(noOfBucket+1));
	b_freq = (int *) malloc(sizeof(int)*(noOfBucket+1));
	memset(b_noOfEntry, 0, sizeof(int)*(noOfBucket+1));
	memset(b_freq, 0, sizeof(int)*(noOfBucket+1));

	for (i = 0; i < noOfBucket; i++)
	{
		for (j = 0; j < noOfBucketEntry[i]; j++)
		{
			bucketCount[bucket[i][j].item[0]]++;
			totalCount[bucket[i][j].item[0]] += bucket[i][j].count;
		}
	}

	for (i = 0; i < noOfItem; i++)
	{
		//printf("%d \n", bucketCount[i]);
		b_noOfEntry[bucketCount[i]]++;
		b_freq[bucketCount[i]]++;
	}

	total = 0;
	for (i = 1; i <= noOfBucket; i++)
	{
		total += b_freq[i];
	}
	total += uncount;

	probBucket[0] =  uncount/(double) total;
	for (i = 1; i <= noOfBucket; i++)
	{
		probBucket[i] = b_freq[i]/(double) total;
	}
	
	for (i = 1; i <= noOfBucket; i++)
	{
		for (j = 0; j < i; j++)
		{
			returnValue[i][j] = (int) ((b_freq[i]/ (double) b_noOfEntry[i])/i);
		}
	}

	free(bucketCount);
	free(totalCount);

	free(b_noOfEntry);
	free(b_freq);

	return returnValue;
}
