
#ifndef TRANS_H
#define TRANS_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct trans_s
{
	int noOfItem;
	int *item;
};

typedef struct trans_s trans;
typedef trans *transPtr;



struct entry_s
{
	int itemsetSize;
	int *item;
	int count;
};

typedef struct entry_s entry;
typedef entry *entryPtr;




struct entryOut_s
{
	int itemsetSize;
	int *item;
	int min;
	int max;
};

typedef struct entryOut_s entryOutStruct;
typedef entryOutStruct *entryOutPtr;





struct hashEntry_s
{
	int *itemSet;
	
	int freq;

	short itemSize;
	short freqNew;
	short *bucketNo;
	short noOfBucket;
	int min;
	int max;
	int rank;
};


typedef struct hashEntry_s hashEntryStruct;
typedef hashEntryStruct *hashEntryPtr;

struct hash_s
{
	int noOfEntry;
	hashEntryPtr entry;
};

typedef struct hash_s hashStruct;
typedef hashStruct *hashPtr;


extern int **noOfEntry;

extern int noOfSkip;

transPtr *readData(char *filename, int noOfTrans);
entryPtr *divideData(transPtr *data, int noOfTrans, int noOfItem, int noOfBucket, int E, int *noOfBucketEntry, int *uncount);
int **analyzeBucket(entryPtr *bucket, int noOfBucket, int noOfItem, int *noOfBucketEntry, int uncount, double *probBucket);

void addEntry(entryPtr *bucket, int noOfPreEntry, int *itemset, int itemsetSize, int freq);
entryPtr *findNewBucket(char *filename, int startIndex, int endIndex, entryPtr **bucket, int curNoOfBucket, int noOfBucket, int **noOfEntry, int topK, int L, double *theta,int *returnK, int bucketSize);


entryOutPtr *processData(char *filename, int noOfTrans, int noOfItem, int noOfBucket, int bucketSize, int currBucketNo, int topK, int L, double *theta, int *returnK);

void printTopOutput(FILE *filePtr, entryOutPtr *output, int *noOfOut, int L);

void printRankEntry(FILE *filePtr, hashEntryPtr *rankEntry, int noOfK);
void printHashEntry(FILE *filePtr, hashEntryPtr en);

#endif


